%global debug_package %{nil}

Name:           sing-box
Version:        1.8.5
Release:        1%{?dist}
Summary:        sing-box is a universal proxy platform.
License:        GPL-3.0
URL:            https://github.com/SagerNet/sing-box

Source0:        %{name}-%{version}.tar.gz
Source1:        https://github.com/SagerNet/sing-box/raw/v%{version}/release/config/config.json
Source2:        https://github.com/SagerNet/sing-box/raw/v%{version}/release/config/sing-box.service
Source3:        https://github.com/SagerNet/sing-box/raw/v%{version}/release/config/sing-box@.service

# BuildRequires:  golang >= 1.20
# BuildRequires:  git-core
%{?systemd_requires}
Requires:       tzdata ca-certificates
Provides:       Productivity/Networking/Web/Proxy


%description
sing-box is a universal proxy platform.


%prep
%autosetup

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags

TAGS="with_quic,with_grpc,with_dhcp,with_wireguard,with_ech,with_utls,with_reality_server,with_acme,with_clash_api,with_v2ray_api,with_gvisor"
LDFLAGS="-X github.com/sagernet/sing-box/constant.Version=v%{version} -s -w -buildid="
go build -v -trimpath -tags "${TAGS}" -ldflags "${LDFLAGS}" -o %{name} ./cmd/sing-box


%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name} %{buildroot}%{_bindir}

%{__install} -d %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{S:1} %{buildroot}%{_sysconfdir}/%{name}/config.json

%{__install} -d %{buildroot}%{_unitdir}
%{__install} -p -m 644 %{S:2} %{buildroot}%{_unitdir}/%{name}.service
%{__install} -p -m 644 %{S:3} %{buildroot}%{_unitdir}/%{name}@.service

# shell completions
%{__install} -d -m 0755 %{buildroot}%{_datadir}/bash-completion/completions
./%{name} completion bash > %{buildroot}%{_datadir}/bash-completion/completions/%{name}
%{__install} -d -m 0755 %{buildroot}%{_datadir}/zsh/site-functions
./%{name} completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_%{name}
%{__install} -d -m 0755 %{buildroot}%{_datadir}/fish/vendor_completions.d
./%{name} completion fish > %{buildroot}%{_datadir}/fish/vendor_completions.d/%{name}.fish


%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}@.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.json
%{_datadir}/bash-completion/completions/%{name}
%{_datadir}/zsh/site-functions/_%{name}
%{_datadir}/fish/vendor_completions.d/%{name}.fish
%license LICENSE
%doc README.md

%changelog
* Sat Feb 3 2024 Teddysun <i@teddysun.com> - 1.8.5-1
- Update version to 1.8.5

* Tue Jan 23 2024 Teddysun <i@teddysun.com> - 1.8.4-1
- Update version to 1.8.4

* Tue Jan 16 2024 Teddysun <i@teddysun.com> - 1.8.2-1
- Update version to 1.8.2

* Sat Jan 13 2024 Teddysun <i@teddysun.com> - 1.8.1-1
- Update version to 1.8.1

* Sat Jan 6 2024 Teddysun <i@teddysun.com> - 1.8.0-1
- Update version to 1.8.0

* Wed Jan 3 2024 Teddysun <i@teddysun.com> - 1.7.8-1
- Update version to 1.7.8

* Sat Dec 30 2023 Teddysun <i@teddysun.com> - 1.7.7-1
- Update version to 1.7.7

* Fri Dec 22 2023 Teddysun <i@teddysun.com> - 1.7.6-1
- Update version to 1.7.6

* Tue Dec 12 2023 Teddysun <i@teddysun.com> - 1.7.5-1
- Update version to 1.7.5

* Sat Dec 9 2023 Teddysun <i@teddysun.com> - 1.7.4-1
- Update version to 1.7.4

* Fri Dec 8 2023 Teddysun <i@teddysun.com> - 1.7.3-1
- Update version to 1.7.3

* Mon Dec 4 2023 Teddysun <i@teddysun.com> - 1.7.2-1
- Update version to 1.7.2

* Sat Dec 2 2023 Teddysun <i@teddysun.com> - 1.7.1-1
- Update version to 1.7.1

* Thu Nov 30 2023 Teddysun <i@teddysun.com> - 1.7.0-1
- Update version to 1.7.0

* Tue Nov 28 2023 Teddysun <i@teddysun.com> - 1.6.7-1
- Update version to 1.6.7

* Tue Nov 21 2023 Teddysun <i@teddysun.com> - 1.6.6-1
- Update version to 1.6.6

* Thu Nov 16 2023 Teddysun <i@teddysun.com> - 1.6.5-1
- Update version to 1.6.5

* Tue Nov 14 2023 Teddysun <i@teddysun.com> - 1.6.4-1
- Update version to 1.6.4

* Fri Nov 10 2023 Teddysun <i@teddysun.com> - 1.6.3-1
- Update version to 1.6.3

* Wed Nov 08 2023 Teddysun <i@teddysun.com> - 1.6.2-1
- Update version to 1.6.2

* Mon Nov 06 2023 Teddysun <i@teddysun.com> - 1.6.1-1
- Initial version 1.6.1

